/*
================================================================================
  RPL/2 (R) version 4.1.21
  Copyright (C) 1989-2015 Dr. BERTRAND Jol

  This file is part of RPL/2.

  RPL/2 is free software; you can redistribute it and/or modify it
  under the terms of the CeCILL V2 License as published by the french
  CEA, CNRS and INRIA.
 
  RPL/2 is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the CeCILL V2 License
  for more details.
 
  You should have received a copy of the CeCILL License
  along with RPL/2. If not, write to info@cecill.info.
================================================================================
*/


#include "rpl-conv.h"


/*
================================================================================
  Positionnement d'un drapeau d'indicateur  1
================================================================================
  Entre :
	- pointeur sur la structure processus
	- numero du drapeau  mettre  1 (INTEGER*1)
--------------------------------------------------------------------------------
  Sortie : nant
--------------------------------------------------------------------------------
  Effets de bord : nant
================================================================================
*/

void
sf(struct_processus *s_etat_processus, unsigned char indice_drapeau)
{
	t_8_bits			masque;

	unsigned char		indice_bit;
	unsigned char		indice_bloc;
	unsigned char		taille_bloc;

	indice_drapeau--;
	taille_bloc = sizeof(t_8_bits) * 8;
	indice_bloc = indice_drapeau / taille_bloc;
	indice_bit = indice_drapeau % taille_bloc;

	masque = (t_8_bits) (((t_8_bits) 1) << (taille_bloc - indice_bit - 1));

	(*s_etat_processus).drapeaux_etat[indice_bloc] |= masque;
}


/*
================================================================================
  Positionnement d'un drapeau d'indicateur  0
================================================================================
  Entre :
	- pointeur sur la structure processus
	- numero du drapeau  mettre  0 (INTEGER*1)
--------------------------------------------------------------------------------
  Sortie : nant
--------------------------------------------------------------------------------
  Effets de bord : nant
================================================================================
*/

void
cf(struct_processus *s_etat_processus, unsigned char indice_drapeau)
{
	t_8_bits			masque;

	unsigned char		indice_bit;
	unsigned char		indice_bloc;
	unsigned char		taille_bloc;

	indice_drapeau--;
	taille_bloc = sizeof(t_8_bits) * 8;
	indice_bloc = indice_drapeau / taille_bloc;
	indice_bit = indice_drapeau % taille_bloc;

	masque = (t_8_bits) (~(((t_8_bits) 1) << (taille_bloc - indice_bit - 1)));

	(*s_etat_processus).drapeaux_etat[indice_bloc] &= masque;
}


/*
================================================================================
  Routine renvoyant l'tat d'un indicateur
================================================================================
  Entre :
    - pointeur sur la structure processus
    - numero du drapeau  mettre  0 (INTEGER*1)
--------------------------------------------------------------------------------
  Sortie : drapeau
--------------------------------------------------------------------------------
  Effets de bord : nant
================================================================================
*/

logical1
test_cfsf(struct_processus *s_etat_processus, unsigned char indice_drapeau)
{
	t_8_bits			masque;

	unsigned char		indice_bit;
	unsigned char		indice_bloc;
	unsigned char		taille_bloc;

	indice_drapeau--;
	taille_bloc = sizeof(t_8_bits) * 8;
	indice_bloc = indice_drapeau / taille_bloc;
	indice_bit = indice_drapeau % taille_bloc;

	masque = (t_8_bits) (((t_8_bits) 1) << (taille_bloc - indice_bit - 1));

	return((((*s_etat_processus).drapeaux_etat[indice_bloc] & masque) != 0)
			? d_vrai : d_faux);
}

// vim: ts=4
