/*
================================================================================
  RPL/2 (R) version 4.1.21
  Copyright (C) 1989-2015 Dr. BERTRAND Jol

  This file is part of RPL/2.

  RPL/2 is free software; you can redistribute it and/or modify it
  under the terms of the CeCILL V2 License as published by the french
  CEA, CNRS and INRIA.
 
  RPL/2 is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the CeCILL V2 License
  for more details.
 
  You should have received a copy of the CeCILL License
  along with RPL/2. If not, write to info@cecill.info.
================================================================================
*/


#ifndef INCLUSION_USAGE
#define INCLUSION_USAGE
#define USAGES_RC		"/rc"
#define USAGES_TITRE	"/titre"

static unsigned char *usages[] =
		{
			USAGES_TITRE, "Control structures :", "Structures de contrle :",
				"IF/THEN/(ELSEIF/THEN)/(ELSE)/END", "IFT", "IFTE",
				"SELECT/CASE/THEN/END/(DEFAULT)/END",
			USAGES_RC,
			USAGES_TITRE, "Error handling :", "Reprise sur erreur :",
				"CLRERR", "ERRM", "ERRN", "IFERR/THEN/(ELSE)/END",
			USAGES_RC,
			USAGES_TITRE, "Loops providing a count",
				"Boucles dfinies avec compteur",
				"FOR/(CYCLE)/(EXIT)/NEXT", "FOR/(CYCLE)/(EXIT)/STEP",
				"FORALL/(CYCLE)/(EXIT)/NEXT",
			USAGES_RC,
			USAGES_TITRE, "Loops without count",
				"Boucles dfinies sans compteur",
				"START/(CYCLE)/(EXIT)/NEXT", "START/(CYCLE)/(EXIT)/STEP",
			USAGES_RC,
			USAGES_TITRE, "Undefined loops", "Boucles indfinies",
				"DO/(EXIT)/UNTIL/(EXIT)/END",
				"WHILE/(EXIT)/REPEAT/(EXIT)/END",
			USAGES_RC,
			USAGES_TITRE, "Inputs/outputs", "Entres/sorties",
				"BEEP", "CLMF", "DISP", "INPUT", "KEY", "PROMPT",
			USAGES_RC,
			USAGES_TITRE, "Debugging", "Dverminage",
				"CONT", "HALT", "SST",
			USAGES_RC,
			USAGES_TITRE, "Stack handling", "Oprations sur la pile",
				"CLEAR", "COPY", "DEPTH", "DROP", "DROP2", "DROPN", "DUP",
				"DUP2", "DUPN", "EDIT", "OVER", "PICK", "ROLL", "ROLLD",
				"ROT", "SWAP",
			USAGES_RC,
			USAGES_TITRE, "Working with variables",
				"Manipulation des variables",
				"->", "CLUSR", "PARAMETER", "PRIVATE", "PROTECT",
				"PURGE", "RCEQ", "RCL", "RECALL", "SAVE", "SCONJ", "SHARED",
				"SINV",
				"SNEG", "STATIC", "STEQ", "STO", "STO+", "STO-", "STO*", "STO/",
				"STORE", "UNPROTECT", "VARIABLE", "VARS", "VISIT", "VOLATILE",
			USAGES_RC,
			USAGES_TITRE, "Arithmetical operations and elementary calculus",
				"Arithmrique et calculs lmentaires",
				"+", "-", "*", "/", "^ (**)", "=", "%", "%CH", "%T",
				"ABS", "ARG",
				"C->R", "CEIL", "CONJ", "DECR", "DER", "DFT", "EVAL",
				"FACT", "FFT", "FLOOR", "FP", "IDFT", "IFFT",
				"IM", "INCR", "INT", "INV", "IP", "MANT", "MAX", "MCLRIN",
				"MIN", "MOD", "NEG", "->NUM", "P->R", "->Q", "R->C", "R->P",
				"RE",
				"RELAX", "SIGN", "SQ", "SQRT", "TAYLR", "XPON", "XROOT",
			USAGES_RC,
			USAGES_TITRE, "Constants", "Constantes",
				"e", "FALSE", "i", "infinity", "PI", "TRUE",
			USAGES_RC,
			USAGES_TITRE, "Formatting", "Formats",
				"ENG", "FIX", "RND", "SCI", "STD", "TRNC",
			USAGES_RC,
			USAGES_TITRE, "Logical and binary operations",
				"Fonctions logiques et arithmtique binaire",
				"<", "<= (=<)", "<>", ">", ">= (=>)", "==",
				"AND", "ASL", "ASR", "B->R", "BIN", "CF", "DEC", "EQV", "FC?",
				"FC?C", "FC?S", "FS?", "FS?C", "FS?S", "HEX", "IN", "NOT",
				"OCT", "OR", "R->B", "RCLF", "RCWS", "RL", "RLB", "RR", "RRB",
				"SAME", "SF", "SL", "SLB", "SR", "SRB", "STOF", "STWS", "XOR",
			USAGES_RC,
			USAGES_TITRE, "Trigonometry", "Fonctions trigonomtriques",
				"ACOS", "ASIN", "ATAN",
				"COS", "D->R", "DEG", "->HMS", "HMS->", "HMS-", "HMS+",
				"R->D", "RAD", "SIN", "TAN",
			USAGES_RC,
			USAGES_TITRE, "Logarithms", "Fonctions logarithmiques",
				"ACOSH", "ALOG", "ASINH", "ATANH",
				"COSH", "EXP", "EXPM", "LN", "LNP1", "LOG", "SINH", "TANH",
			USAGES_RC,
			USAGES_TITRE, "Special functions", "Fonctions spciales",
				"BESSEL", "GAMMA",
			USAGES_RC,
			USAGES_TITRE, "Statistics", "Statistiques",
				"CLS", "COLS", "COMB", "CORR", "COV", "DRWS", "MAXS", "MEAN",
				"MINS", "NRAND", "NS", "PCOV", "PERM", "PSDEV", "PVAR", "RAND",
				"RCLS", "RDGN", "RDZ", "S-", "S+",
				"SCLS", "SDEV", "SPAR", "STOS",
				"SX", "SX2", "SXY", "SY", "SY2", "TOT", "UTPC", "UTPF",
				"UTPN", "UTPT", "VAR", "XCOL", "YCOL",
			USAGES_RC,
			USAGES_TITRE, "Dealing with matrix and vector",
				"Manipulation des vecteurs et des matrices",
				"->ARRAY (->ARRY)", "ARRAY-> (ARRY->)", "CNRM", "COL+", "COL-",
				"COL->", "->COL",
				"CON", "COND", "CROSS", "CSWP", "DET", "DIAG->", "->DIAG",
				"DOT", "EGV", "EGVL", "GEGV",
				"GEGVL", "GET", "GETC", "GETI", "GETR", "GLEGV", "GREGV",
				"IDN", "LCHOL", "LEGV", "LQ", "LSQ", "LU", "MAX", "MIN", "PUT",
				"PUTC", "PUTI", "PUTR", "QR", "RANK",
				"RCI", "RCIJ", "RDM", "REGV",
				"RNRM", "ROW+", "ROW-", "ROW->", "->ROW",
				"RSD", "RSWP", "SCHUR", "SIZE", "SQ", "SVD", "SVL", "TRN",
				"UCHOL",
			USAGES_RC,
			USAGES_TITRE, "Dealing with tables",
				"Manipulation des tables",
				"CRTAB", "GET", "L->T", "PUT", "T->L", "->TABLE", "TABLE->",
			USAGES_RC,
			USAGES_TITRE, "Lists", "Manipulation des listes",
				"GET", "GETI", "HEAD", "L->T",
				"->LIST", "LIST->", "POS", "PUT", "PUTI",
				"REPL", "REVLIST", "SIZE", "SORT", "SUB", "T->L", "TAIL",
			USAGES_RC,
			USAGES_TITRE, "Strings", "Chanes de caractres",
				"CHR", "CURRENC", "LCASE",
				"->STR", "STR->", "NUM", "POS", "RECODE", "REGEX", "REPL",
				"RGDL", "RGDR",
				"SIZE", "SREV", "SUB", "TOKENIZE", "TRIM", "UCASE",
			USAGES_RC,
			USAGES_TITRE, "Expressions", "Manipulation des expressions",
				"OBGET", "OBSUB", "EXGET", "EXSUB",
			USAGES_RC,
			USAGES_TITRE, "File handling", "Gestion des fichiers",
				"APPEND", "BACKSPACE", "CLOSE",
				"CREATE", "DELETE", "FORMAT",
				"INQUIRE", "LOCK", "OPEN", "POLL", "READ", "REWIND",
				"SYNC", "TARGET", "UNLOCK", "WFLOCK", "WFSOCK", "WRITE",
			USAGES_RC,
			USAGES_TITRE, "Graphical output and printing",
				"Sorties graphiques et papier",
				"*D", "*H", "*S", "*W", "AUTOSCALE", "AXES", "CENTR", "CLLCD",
				"CR", "DEPND", "DGTIZ",
				"DRAW", "DRAX", "ERASE", "EYEPT", "FUNCTION",
				"HISTOGRAM", "INDEP", "KEYLABEL", "KEYTITLE",
				"LABEL", "LCD->", "->LCD",
				"LINE", "LOGSCALE", "MARK", "NEWPLANE", 
				"PAPER", "PARAMETRIC", "PERSIST", "PLOT",
				"PLOTTER", "PMAX", "PMIN",
				"POLAR", "PPAR", "PR1", "PRINT", "PRLCD", "PRMD", "PRST",
				"PRSTC", "PRUSR", "PRVAR", "REDRAW", "RES", "SCATTER",
				"SCALE", "SLICE", "SLICESCALE", "TITLE", "WIREFRAME",
			USAGES_RC,
			USAGES_TITRE, "Libraries", "Bibliothques",
				"EXTERNALS", "REMOVE", "USE",
			USAGES_RC,
			USAGES_TITRE, "Multitasking", "Gestion des processus",
				"ATEXIT", "ATPOKE", "CLRATEXIT", "CLRATPOKE",
				"CLRFUSE", "CLRMTX", "CLRSMPHR", "CLRSWI", "CONTINUE",
				"CRITICAL/END", "CRMTX",
				"CRSMPHR", "CSTOP", "DAEMONIZE",
				"DETACH", "FUSE", "ISWI", "MTXLOCK", "MTXSTATUS",
				"MTXTRYLOCK", "MTXUNLOCK",
				"NRPROC", "PEEK", "POKE", "PROCID",
				"RCLSWI", "RECV", "RFUSE",
				"RSTOP", "SCHED", "SEND", 
				"SMPHRDECR", "SMPHRGETV", "SMPHRINCR", "SMPHRTRYDECR",
				"SPAWN", "STOP", "STOSWI",
				"SUSPEND", "SWI",
				"SWILOCK", "SWIQUEUE", "SWISTATUS", "SWIUNLOCK", "WFACK",
				"WFDATA", "WFPOKE", "WFPROC",
				"WFSWI", "YIELD",
			USAGES_RC,
			USAGES_TITRE, "Contexts", "Changement de contextes",
				"CLRCNTXT", "DROPCNTXT", "DUPCNTXT", "PSHCNTXT", "PULCNTXT",
				"SWAPCNTXT",
			USAGES_RC,
			USAGES_TITRE, "Misc", "Instructions diverses",
				"<<", ">>", "ABORT", "ALARM", "BACKTRACE", "CIPHER",
				"COMPRESS", "CONVERT", "COPYRIGHT", "DATE", "DIGEST",
				"HELP", "IMPLICIT", "ITRACE",
				"JDATE", "KILL",
				"KIND", "LAST", "LOCALIZATION",
				"LOGGER", "MEM", "MEMLOCK", "MEMUNLOCK", "PSHPRFL", "PULPRFL",
				"RDATE", "RESTART", 
				"RETURN", "SPLASH", "SYSEVAL", "TIME",
				"TYPE", "UNCOMPRESS", "VERIFY", "VERSION", "WAIT", "WARRANTY",
				"WORKDIR",
			USAGES_RC,
			USAGES_TITRE, "Databases", "Bases de donnes",
				"SQLCONNECT", "SQLDISCONNECT", "SQLQUERY",
			USAGES_RC,
			USAGES_TITRE, "Preprocessing", "Instructions du prprocesseur",
				"#date", 
				"#define", "#defeval", "#elif", "#else", "#endif", "#error",
				"#eval", "#file",
				"#if", "#ifdef", "#ifeq", "#ifndef", "#ifneq",
				"#include", "#line", "#mode", "#undef", "#warning",
		NULL };
#endif

// vim: ts=4
